;=======================================================================
;     FVAf[^MpvO for PB-1000/C,AI-1000
;   F(C)2010-2022 Miyura (miyura321@ybb.ne.jp) 
; ڐA  Fiqze12045@nifty.com)
; sFPB-1000/PB-1000C/AI-1000 + BASICJ[h
;           sɂ͉L̒lȏ̋@B̈mۂĉB
;           PB-1000/C    --- 115oCgȏ
;           AI-1000      --- 132oCgȏ
; ӎFȈRS-232C I/Fgpz肵Ă܂B
;           炩IF̏B
;=======================================================================
;##### MODEL NUMBER #####
PB1000:	EQU	1		;PB-1000
PB1000C:EQU	2		;PB-1000C
AI1000:	EQU	3		;AI-1000
;--------------------------------
MODEL:	EQU	AI1000		;<- p@Lڂ

;------------------------------------------------------------
; AI-1000^PB-2000Cp`
;------------------------------------------------------------
#if (MODEL=AI1000)
BASE:	EQU	&H1000		;vOi[Ԓn
STBIT:	EQU	&H10		;STOP BITʒu(P4)

MEMEN:	EQU	&H0AAE		;t[GA擪|C^
NOWFL:	EQU	&H0D0E		;ݑΏۂɂĂBASICt@CFCB擪Ԓn

OMERR:	EQU	&H457E		;OM Error(01)
FRERR:	EQU	&H45F1		;FR Error(1E)
NDFMK:	EQU	&H46F8		;V[PVt@CGg[쐬
FNSMEM:	EQU	&H4775		;"MEMO"t@C(t@C=$4)
KILL:	EQU	&H5743		;t@C(폜)
;MENU:	EQU	&H5AA6		;MENU[h
MENU:	EQU	&H5425		;MENU[h


BIOS:	EQU	&H9881		;BIOS(BANK0)R[BANK1ɖ߂(FX-870P &H5321)
#endif

;------------------------------------------------------------
; PB-1000^PB-1000Cp`
;------------------------------------------------------------
#if (MODEL=PB1000)|(MODEL=PB1000C)
BASE:	EQU	&H7000		;vOi[Ԓn
;STBIT:	EQU	&H02		;STOP BITʒu(P1)
STBIT:	EQU	&H08		;STOP BITʒu(P3)

MEMEN:	EQU	&H6945		;t[GA擪|C^
NOWFL:	EQU	&H6F54		;ݎgpĂt@C̃AhX

#if MODEL=PB1000
OMERR:	EQU	&HABBD		;OM error
FRERR:	EQU	&HAC30		;FR error

NDFMK:	EQU	&HB1C2		;V[PVt@CGg[쐬
CPMEM:	EQU	&HB6EE		;"MEMO       "WORK1ɓ]
FNSCA:	EQU	&HE80F		;t@C(t@C=ALL)
KILL:	EQU	&HE842		;t@C폜
MENU:	EQU	&HECA6		;MENU[h

#else
OMERR:	EQU	&HAD07		;OM error
FRERR:	EQU	&HAD7F		;FR error

NDFMK:	EQU	&HB2E8		;V[PVt@CGg[쐬
CPMEM:	EQU	&HB81C		;"MEMO       "WORK1ɓ]
FNSCA:	EQU	&HEA03		;t@C(t@C=ALL)
KILL:	EQU	&HEA36		;t@C폜
MENU:	EQU	&HEFBB		;MENU[h
#endif

#endif
	ORG	BASE

	START	INIT

INIT:
#if (MODEL=PB1000)|(MODEL=PB1000C)
	CAL	CPMEM		;"MEMO       "WORK1ɓ]
	CAL	FNSCA		;"MEMO"(t@C=ALL)
	CAL	NC,KILL		;"MEMO"݂폜
	CAL	NDFMK		;"MEMO.S"쐬	($1=&H1A, $2,3=i[JnAhX,$4,5=t@CGg[)
#endif
#if (MODEL=AI1000)
	NA	$4,$31		;Sw($4=&HFF)
	LDW	$28,FNSMEM	;"MEMO"t@CB
	CAL	RCS		;
	LDW	$28,KILL	;t@C폜
	CAL	NC,RCS		;"MEMO"݂폜
	LDW	$28,NDFMK	;"MEMO.S"쐬	($1=&H1A, $2,3=i[JnAhX,$4,5=t@CGg[)
	CAL	RCS		;
#endif
	PRE	IX,NOWFL	;J[\MEMO.Sɍ킹
	STW	$4,(IX+$31)	;

	SBW	$4,$30		;$4,5 <- (DATDI) - 1
	LDW	$10,MENU - 1	;$10,11 I̔ѐ揉l

	PST	IA,$30		;KO1w
	GST	IE,$8		;IEۑ
	PST	IE,$31		;荞݋֎~

LOOP1:	GRE	KY,$6		;14 cycles
	BIU	$6		; 9 cycles, KI1 -> CtO
	JR	C,EXIT		; 9 cycles, BRKꂽI

; ***  STARTDATÅԂ̃NbNTCN1.2 * 95ɐݒ  ***

START:	GPO	$6		; 9 cycles, X^[grbgM
	ANC	$6,STBIT	;12 cycles
	JR	NZ,LOOP1	; 9 cycles
        SBCW    $2,$4		;17 cycles, t[GÃ`FbN
	JR	NC,OMERROR	; 9 cycles
	LD	$7,8		;12 cycles, rbgJE^[̐ݒ

; ***  LOOP2DATA1̊Ԃ̃NbNTCN95ɐݒ  ***

LOOP2:
#if (STBIT=&H2)|(STBIT=&H10)
	LDCM	$0,$0,5,NEXT	;35 cycles, x
NEXT:	NOP			; 6 cycles, x
#endif
#if (STBIT=&H8)
	LDCM	$0,$0,5		;32 cycles, x
#endif

; ***  DATASTOP̊Ԃ̃NbNTCN95ɐݒ  ***

DATA:	GPO	$6		; 9 cycles, f[^rbgM
#if (STBIT=&H2)
	BID	$6		; 9 cycles
#endif
#if (STBIT=&H10)
	DID	$6		; 9 cycles
#endif
#if (STBIT=&H8)
	BIU	$6		; 9 cycles
	DID	$6		; 9 cycles
#endif
	BID	$6		; 9 cycles, MrbgCtOɓ]
	ROD	$0		; 9 cycles, CtO$0̏ʃrbgɌJ荞
	SB	$7,$30		; 9 cycles, rbgJE^[ - 1
	JR	NZ,LOOP2	; 9 cycles

DATA1:	SBC	$0,&H1A		;12 cycles, $0EOFR[hȂI
	JR	Z,EXIT		; 9 cycles,

	STW	$0,($2)		;20 cycles, MoCg + EOFR[h

; *** STOPSTART̊Ԃ̃NbN95ȉɐݒ  ***

STOP:	GPO	$6		; 9 cycles, XgbvrbgM
	ADW	$2,$30		;14 cycles, ݃|C^ + 1
	ANC	$6,STBIT	;12 cycles, Xgbvrbg̃`FbN
	JR	NZ,LOOP1	; 9 cycles

; XgbvrbgM
	LDW	$10,FRERR - 1	;FR error
	JR	EXIT		;

; eʃI[o[
OMERROR:LDW	$10,OMERR - 1	;OM error

; I
EXIT:	PHSW	$11		;ѐVXeX^bNPUSH
	PST	IE,$8		;IEA
	ADW	$2,$30		;
	PRE	IX,MEMEN	;(MEMEN)̍XV
	STW	$2,(IX+$31)	;
	PRE	IX,$4		;IX <- (DATDI) - 1
	LD	$0,4		;
	STW	$2,(IX+$0)	;"MEMO.S"̍ŏIAhXXV
#if (MODEL=AI1000)
	PST	UA,&H54		;oN1w
#endif
	RTN			;$10,11 + 1̃AhXɔ

#if (MODEL=AI1000)
;------------------------------------------------------------
; BIOSĂяo
; ́F$28,$29 --- BIOSĂяoAhX
;------------------------------------------------------------
RCS:	PST	UA,&H54		;BIOSĂяo
	JP	BIOS		;
#endif
